/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * transport_int.h
 * ---------------
 *
 * Communication transport protocol
 */


#ifndef __impulse_comms_transport_int_h
#define __impulse_comms_transport_int_h

#include <impulse/comms/transport.h>

/*                            ======--------======                           */

struct _impulse_transport_module
{
  impulse_transport_impl impl;
  impulse_int nprotocol;
  impulse_unistring *protocol;
  
  void (*init)(void);
  void (*cleanup)(void);
};

typedef struct _impulse_transport_module *impulse_transport_module;

void impulse_transport_register(impulse_transport_module module);
void impulse_transport_deregister(impulse_transport_module module);

impulse_transport_impl impulse_transport_load(impulse_unistring protocol);
void impulse_transport_unload(impulse_unistring protocol);

#endif

/* End of file */
